CREATE TABLE COMPTE (
	COMPTE_DISCRIMINATOR VARCHAR(31) NOT NULL,
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_89D90765_F330_449D_B742_38E898909074) NOT NULL AUTO_INCREMENT,
	IBAN VARCHAR(255),
	SOLDE DOUBLE NOT NULL,
	TITULAIRE VARCHAR(255),
	TAUX DOUBLE,
	CONSTRAINT CONSTRAINT_7 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_7 ON COMPTE (ID);

CREATE TABLE COMPTE_BANCAIRE (
	ID BIGINT NOT NULL,
	IBAN VARCHAR(255),
	SOLDE DOUBLE NOT NULL,
	TITULAIRE VARCHAR(255),
	CONSTRAINT CONSTRAINT_D PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_D ON COMPTE_BANCAIRE (ID);

CREATE TABLE COMPTE_EPARGNE (
	ID BIGINT NOT NULL,
	IBAN VARCHAR(255),
	SOLDE DOUBLE NOT NULL,
	TITULAIRE VARCHAR(255),
	TAUX DOUBLE NOT NULL,
	CONSTRAINT CONSTRAINT_8 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_8 ON COMPTE_EPARGNE (ID);

CREATE TABLE QUIZ (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_16E346E4_AAA0_41FD_AA7E_D8912710EC5A) NOT NULL AUTO_INCREMENT,
	TITLE VARCHAR(255),
	VERSION INTEGER NOT NULL,
	CONSTRAINT CONSTRAINT_26 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_26 ON QUIZ (ID);

CREATE TABLE QUESTIONS (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_FC66B9A0_5CB2_4217_8E7F_9396AB847613) NOT NULL AUTO_INCREMENT,
	MULTIPLE BOOLEAN NOT NULL,
	NUM_ORDER INTEGER NOT NULL,
	QST_TEXT VARCHAR(255),
	VERSION INTEGER NOT NULL,
	QUIZ_ID BIGINT,
	CONSTRAINT CONSTRAINT_3 PRIMARY KEY (ID)
);
CREATE INDEX FK8NTCSBYFIISO3XXQM406WBWJP_INDEX_3 ON QUESTIONS (QUIZ_ID);
CREATE UNIQUE INDEX PRIMARY_KEY_3 ON QUESTIONS (ID);

CREATE TABLE REPONSES (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_104469C1_6C5B_425A_BFFF_090018D18E6D) NOT NULL AUTO_INCREMENT,
	CORRECT BOOLEAN NOT NULL,
	RESP_TEXT VARCHAR(255),
	VERSION INTEGER NOT NULL,
	QUESTION_ID BIGINT,
	CONSTRAINT CONSTRAINT_1 PRIMARY KEY (ID)
);
CREATE INDEX FKT9MAHD2WVDURYN2YFRRO2NXEF_INDEX_1 ON REPONSES (QUESTION_ID);
CREATE UNIQUE INDEX PRIMARY_KEY_1 ON REPONSES (ID);

CREATE TABLE EMPLOYES (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_0D8046F1_0D64_4555_A4F6_5ACB7905EB1C) NOT NULL AUTO_INCREMENT,
	VERSION INTEGER NOT NULL,
	CODE_POSTAL VARCHAR(255),
	RUE VARCHAR(255),
	VILLE VARCHAR(255),
	CODE_POSTAL_PRO VARCHAR(255),
	RUE_PRO VARCHAR(255),
	VILLE_PRO VARCHAR(255),
	NOM VARCHAR(255),
	PRENOM VARCHAR(255),
	CONSTRAINT CONSTRAINT_75 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_75 ON EMPLOYES (ID);

CREATE TABLE MAIRES (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_C5E21F32_DE4C_4B6A_9307_A658A20C06D3) NOT NULL AUTO_INCREMENT,
	NOM VARCHAR(255),
	PRENOM VARCHAR(255),
	VERSION INTEGER NOT NULL,
	CONSTRAINT CONSTRAINT_87 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_87 ON MAIRES (ID);

CREATE TABLE COMMUNES (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_0111C3BF_7EF5_4AC2_9233_E6259A50AA49) NOT NULL AUTO_INCREMENT,
	NOM VARCHAR(255),
	VERSION INTEGER NOT NULL,
	ID_MAIRE BIGINT,
	CONSTRAINT CONSTRAINT_A PRIMARY KEY (ID)
);
CREATE INDEX FKIUX9P90V53YJSC78Q7EJ2AK2H_INDEX_A ON COMMUNES (ID_MAIRE);
CREATE UNIQUE INDEX PRIMARY_KEY_A ON COMMUNES (ID);

CREATE TABLE ETIQUETTES (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_84B09015_7788_487C_B955_EABB2FC64540) NOT NULL AUTO_INCREMENT,
	VERSION INTEGER NOT NULL,
	NOM VARCHAR(255) NOT NULL,
	CONSTRAINT CONSTRAINT_6 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_6 ON ETIQUETTES (ID);

CREATE TABLE COORDONNEES (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_428A64E3_FBC0_4770_8522_97C2C112BDCE) NOT NULL AUTO_INCREMENT,
	VERSION INTEGER NOT NULL,
	LATITUDE DOUBLE NOT NULL,
	LONGITUDE DOUBLE NOT NULL,
	CONSTRAINT CONSTRAINT_F PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_F ON COORDONNEES (ID);

CREATE TABLE NATIONS (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_A9D756DE_4BDA_40C4_AAA1_EBE91B2EB818) NOT NULL AUTO_INCREMENT,
	VERSION INTEGER NOT NULL,
	NOM VARCHAR(100) NOT NULL,
	CONSTRAINT CONSTRAINT_9 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_9 ON NATIONS (ID);

CREATE TABLE MONUMENTS (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_58325A78_0F64_4B94_9594_681E43E49B22) NOT NULL AUTO_INCREMENT,
	VERSION INTEGER NOT NULL,
	ANNEE_CONSTRUCTION INTEGER NOT NULL,
	NOM VARCHAR(255) NOT NULL,
	ID_COORDONNEE BIGINT,
	NATION_ID BIGINT,
	CONSTRAINT CONSTRAINT_5 PRIMARY KEY (ID)
);
CREATE INDEX FK40S11JFRLFQ0SWGLG8R6FXHN0_INDEX_5 ON MONUMENTS (ID_COORDONNEE);
CREATE INDEX FKJ23QS5S3OYP4UUDSO25V11JMY_INDEX_5 ON MONUMENTS (NATION_ID);
CREATE UNIQUE INDEX PRIMARY_KEY_5 ON MONUMENTS (ID);

CREATE TABLE MONUMENTS_ETIQUETTES (
	MONUMENT_ID BIGINT NOT NULL,
	ETIQUETTES_ID BIGINT NOT NULL,
	CONSTRAINT CONSTRAINT_2 PRIMARY KEY (MONUMENT_ID,ETIQUETTES_ID)
);
CREATE INDEX FKGKLA2V6Q23CVWEP5MVO3PO1E4_INDEX_2 ON MONUMENTS_ETIQUETTES (ETIQUETTES_ID);
CREATE INDEX FKRON9XIJUY90EJEOF0G4H9HOHW_INDEX_2 ON MONUMENTS_ETIQUETTES (MONUMENT_ID);
CREATE UNIQUE INDEX PRIMARY_KEY_2 ON MONUMENTS_ETIQUETTES (MONUMENT_ID,ETIQUETTES_ID);

ALTER TABLE MONUMENTS_ETIQUETTES ADD CONSTRAINT FKGKLA2V6Q23CVWEP5MVO3PO1E4 FOREIGN KEY (ETIQUETTES_ID) REFERENCES ETIQUETTES(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE MONUMENTS_ETIQUETTES ADD CONSTRAINT FKRON9XIJUY90EJEOF0G4H9HOHW FOREIGN KEY (MONUMENT_ID) REFERENCES MONUMENTS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;

CREATE TABLE FOURNISSEURS (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_14353D51_9FDC_45C8_91DA_AD68B0480656) NOT NULL AUTO_INCREMENT,
	NOM VARCHAR(255),
	VERSION INTEGER NOT NULL,
	CONSTRAINT CONSTRAINT_F6 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_F6 ON FOURNISSEURS (ID);

CREATE TABLE MARQUE (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_8AD76C98_AA80_4AA1_9FDC_BA8E44D718B1) NOT NULL AUTO_INCREMENT,
	NOM VARCHAR(255),
	VERSION INTEGER NOT NULL,
	CONSTRAINT CONSTRAINT_871 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_871 ON MARQUE (ID);

CREATE TABLE PRODUITS (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_B6E25D54_6290_445D_9851_C288C523CD38) NOT NULL AUTO_INCREMENT,
	CONDITIONNNEMENT VARCHAR(255),
	DESCRIPTION VARCHAR(60),
	PRIX DOUBLE NOT NULL,
	ID_MARQUE BIGINT,
	IMAGE BLOB,
	CONSTRAINT CONSTRAINT_F2 PRIMARY KEY (ID)
);
CREATE INDEX FKM9CCYS6XF2CNQ769B0YCIEG88_INDEX_B ON PRODUITS (ID_MARQUE);
CREATE UNIQUE INDEX PRIMARY_KEY_B ON PRODUITS (ID);

CREATE TABLE PRODUITS2FOURNISSEURS (
	ID_PRODUIT BIGINT NOT NULL,
	ID_FOURNISSEUR BIGINT NOT NULL
);
CREATE INDEX FK3J95FWDBH1JPSDMFAPFKCIFAN_INDEX_2 ON PRODUITS2FOURNISSEURS (ID_FOURNISSEUR);
CREATE INDEX FKL3WXF8NJLRIGOJMEUXJ67MJW6_INDEX_2 ON PRODUITS2FOURNISSEURS (ID_PRODUIT);


CREATE TABLE COMMENTAIRES_PRODUITS (
	PRODUIT_ID BIGINT NOT NULL,
	COMMENTAIRES VARCHAR(255)
);
CREATE INDEX FK6F8V1DRXM940W09SDOJDCX1JC_INDEX_D ON COMMENTAIRES_PRODUITS (PRODUIT_ID);

CREATE TABLE USERS (
	ID BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_9E138F5C_4FCD_41AB_A899_684E6D08AD50) NOT NULL AUTO_INCREMENT,
	PASSWORD VARCHAR(255),
	USER_NAME VARCHAR(255),
	CONSTRAINT CONSTRAINT_4 PRIMARY KEY (ID)
);
CREATE UNIQUE INDEX PRIMARY_KEY_4 ON USERS (ID);

CREATE TABLE AUTHORITY (
	AUTHORITHY VARCHAR(255) NOT NULL,
	CONSTRAINT CONSTRAINT_FE PRIMARY KEY (AUTHORITHY)
);
CREATE UNIQUE INDEX PRIMARY_KEY_FE ON AUTHORITY (AUTHORITHY);


CREATE TABLE USERS_AUTHORITY (
	USER_ID BIGINT NOT NULL,
	AUTHORITY_AUTHORITHY VARCHAR(255) NOT NULL
);
CREATE INDEX FKF1RQ4MVKJ303O9C78BV8NOV5_INDEX_B ON USERS_AUTHORITY (USER_ID);
CREATE INDEX FKPAPGBIBSAE46UUS9PBOK6AQEH_INDEX_B ON USERS_AUTHORITY (AUTHORITY_AUTHORITHY);
USERS_AUTHORITY foreign keys

ALTER TABLE COMMENTAIRES_PRODUITS ADD CONSTRAINT FK6F8V1DRXM940W09SDOJDCX1JC FOREIGN KEY (PRODUIT_ID) REFERENCES PRODUITS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE PRODUITS2FOURNISSEURS ADD CONSTRAINT FK3J95FWDBH1JPSDMFAPFKCIFAN FOREIGN KEY (ID_FOURNISSEUR) REFERENCES FOURNISSEURS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE PRODUITS2FOURNISSEURS ADD CONSTRAINT FKL3WXF8NJLRIGOJMEUXJ67MJW6 FOREIGN KEY (ID_PRODUIT) REFERENCES PRODUITS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE PRODUITS2FOURNISSEURS ADD CONSTRAINT FK3J95FWDBH1JPSDMFAPFKCIFAN FOREIGN KEY (ID_FOURNISSEUR) REFERENCES FOURNISSEURS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE PRODUITS2FOURNISSEURS ADD CONSTRAINT FKL3WXF8NJLRIGOJMEUXJ67MJW6 FOREIGN KEY (ID_PRODUIT) REFERENCES PRODUITS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE PRODUITS ADD CONSTRAINT FKM9CCYS6XF2CNQ769B0YCIEG88 FOREIGN KEY (ID_MARQUE) REFERENCES MARQUE(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE MONUMENTS ADD CONSTRAINT FK40S11JFRLFQ0SWGLG8R6FXHN0 FOREIGN KEY (ID_COORDONNEE) REFERENCES COORDONNEES(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE MONUMENTS ADD CONSTRAINT FKJ23QS5S3OYP4UUDSO25V11JMY FOREIGN KEY (NATION_ID) REFERENCES NATIONS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE COMMUNES ADD CONSTRAINT FKIUX9P90V53YJSC78Q7EJ2AK2H FOREIGN KEY (ID_MAIRE) REFERENCES MAIRES(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE QUESTIONS ADD CONSTRAINT FK8NTCSBYFIISO3XXQM406WBWJP FOREIGN KEY (QUIZ_ID) REFERENCES QUIZ(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE REPONSES ADD CONSTRAINT FKT9MAHD2WVDURYN2YFRRO2NXEF FOREIGN KEY (QUESTION_ID) REFERENCES QUESTIONS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;

ALTER TABLE USERS_AUTHORITY ADD CONSTRAINT FKF1RQ4MVKJ303O9C78BV8NOV5 FOREIGN KEY (USER_ID) REFERENCES USERS(ID) ON DELETE RESTRICT ON UPDATE RESTRICT;
ALTER TABLE USERS_AUTHORITY ADD CONSTRAINT FKPAPGBIBSAE46UUS9PBOK6AQEH FOREIGN KEY (AUTHORITY_AUTHORITHY) REFERENCES AUTHORITY(AUTHORITHY) ON DELETE RESTRICT ON UPDATE RESTRICT;